// vheap.h
// https://www.c-sharpcorner.com/article/writing-our-own-memory-manager-in-ccpp/
// https://pritamzope.wordpress.com/
// An enthusiastic Programmer, Software Developer, Researcher having experience of working with various technologies and programming
// languages such as C/C++,C#,Java,Python etc.

#pragma once

#include "memmap.h"
#include <atomic>

typedef struct __s_block{
    struct __s_block *next;
    size_t size;
} _SBLOCK;

#define BLOCK_SIZE sizeof(_SBLOCK)
#define VFILE_SIZE 4294967296
#define VFILE_NAME "D:\\tmp\\workingset%u.dmp"

class vheap
{
public:
    vheap();
    ~vheap(){}

private:
    friend class oheap;

    void* allocateNextMemBlock(size_t size_p);
    void freeMemBlock(_SBLOCK *head_p);

    void* sbrk(size_t size_p);

    void vunlock();

    std::atomic<bool> spinmutex;

    int idxBuf;
    typedef struct SomeSpace
    {
        char space[sizeof(memmap::MMapBuffer)];
    } SomeSpace;

    SomeSpace m_SomeSpace[1024];
    memmap::MMapBuffer* m_Buffers[1024];

    char* segstart;
    char* segend;
    char* memcounter;

    _SBLOCK *freebase;
} ;

