// oheap.h
#pragma once

#include <Windows.h>
#include <thread>
#include <atomic>

class __declspec(dllexport) oheap
{
public:
    static oheap* get();
    ~oheap();
    
    void* malloc(size_t size_p);
    void free(void* p);
    static void start();

private:
    oheap();
    void oheap_();

    typedef void* (oheap::*mallocfct_t)(size_t size_p);
    std::atomic<mallocfct_t> mallocfct;

    void* sloppymalloc(size_t size_p);
    void* stopmalloc(size_t size_p);
    void* speedymalloc(size_t size_p);

    std::atomic<DWORD> sleepCount;
    std::atomic<bool> stopMallocs;
    std::atomic<bool> runThreads;
    std::thread thread;
};

